﻿//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  VBScriptの正規表現機能を使用したテスト
//  テキスト内にの文字列置換
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2010年06月23日 ～
//  2014年08月04日 ～
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro + vbscript.dll 5.8.7
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, VBScript_RegExp_55_TLB, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  テキスト内の文字列置換テスト
//  Edit1.Text  対象のテキスト
//  Edit2.Text  その中の置換対象文字列パターン
//  Edit3.Text  この文字列に置換する
//
//  文字列'(シングルクォーテーション)使用の注意
//  文字として文字列中に書く場合は''と2つ続けて書く
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  Edit1.Text := '?好Ｄｅｌｐｈｉ２０１０?????叱鮭';

  //検索条件(パターン)
  //対象文字列の先頭がDelphiかを検査(^がなければ文字列内の検索)
  Edit2.Text := 'Ｄｅｌｐｈｉ';

  Edit3.Text := 'DELPHI';
end;

//=============================================================================
//  置換実行
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  ARegExp : TRegExp;
begin
  ARegExp := TRegExp.Create(Self);
  try
    //大文字と小文字を区別しない
    ARegExp.IgnoreCase := True;
    //テキスト全てを対照に検索
    ARegExp.Global := True;
    //置換対象文字列パターン
    ARegExp.Pattern := Edit2.Text;

    //置換して結果をTLabelに表示
    //Edit2.TextのパターンをEdit2.Textの文字列に置換
    Label1.Caption := ARegExp.Replace(Edit1.Text, Edit3.Text);
  finally
    FreeAndNil(ARegExp);
  end;
end;

end.
